% Spigoli.pl

% Programma che partendo da una configurazione in cui tutti i pezzi sono fuori posto riesce a sistemare le
% posizioni degli spigoli, senza curarsi per della posizione dei vertici.
% In realt all'inizio cercavo di non toccare i vertici, ma per una soluzione ci voleva pi di un ora, quando ci arrivava.
% Inserendo anche le mosse singole: soluzione in 31 secondi (spigoli posizionati, ma non orientati).

% [[pezzo,direzione]]:
% b=bianco, v=verde, r=rosso, a=arancio, g=giallo, c=cobalto (blu).
% x direzione bianco-cobalto, y direzione verde-giallo, z direzione rosso-arancio.
% la prima lettera indica il colore rispetto cui  riferita la direzione.
spigoli_ok([[bv,x],[br,x],[bg,x],[ba,x],[vr,y],[gr,y],[ga,y],[va,y],[ca,x],[cg,x],[cr,x],[cv,x]]).

% MOSSA_S	 Spostano tre spigoli; dei vertici mi disinteresso (sono 24).
mossa_s(bv10,[[S1,D1],[S2,D2],S3,S4,S5,S6,S7,[S8,D8],S9,S10,S11,S12],
	     [[S8,Dc],[S1,Da],S3,S4,S5,S6,S7,[S2,Db],S9,S10,S11,S12]):-
	cambia_dir(yz,D1,Da), ruota_antiorario(D2,Db), cambia_dir(xz,D8,Dc). % [b,v,b,v,b,v3,b3,v3,b3,v3]
mossa_s(b3v310, [[S1,D1],S2,S3,[S4,D4],[S5,D5],S6,S7,S8,S9,S10,S11,S12],
		[[S5,Dc],S2,S3,[S1,Da],[S4,Db],S6,S7,S8,S9,S10,S11,S12]):-
	cambia_dir(yz,D1,Da), ruota_antiorario(D4,Db), cambia_dir(xz,D5,Dc). % [b3,v3,b3,v3,b3,v,b,v,b,v]
mossa_s(br10,[S1,[S2,D2],[S3,D3],S4,[S5,D5],S6,S7,S8,S9,S10,S11,S12],
	     [S1,[S5,Dc],[S2,Da],S4,[S3,Db],S6,S7,S8,S9,S10,S11,S12]):-
	cambia_dir(yz,D2,Da), ruota_orario(D3,Db), cambia_dir(xy,D5,Dc). %  [b,r,b,r,b,r3,b3,r3,b3,r3]
mossa_s(b3r310, [[S1,D1],[S2,D2],S3,S4,S5,[S6,D6],S7,S8,S9,S10,S11,S12],
		[[S2,Db],[S6,Dc],S3,S4,S5,[S1,Da],S7,S8,S9,S10,S11,S12]):-
	ruota_orario(D1,Da), cambia_dir(yz,D2,Db), cambia_dir(xy,D6,Dc). % [b3,r3,b3,r3,b3,r,b,r,b,r]
mossa_s(bg10,[S1,S2,[S3,D3],[S4,D4],S5,[S6,D6],S7,S8,S9,S10,S11,S12],
	     [S1,S2,[S6,Dc],[S3,Da],S5,[S4,Db],S7,S8,S9,S10,S11,S12]):-
	cambia_dir(yz,D3,Da), ruota_antiorario(D4,Db), cambia_dir(xz,D6,Dc). % [b,g,b,g,b,g3,b3,g3,b3,g3]
mossa_s(b3g310, [S1,[S2,D2],[S3,D3],S4,S5,S6,[S7,D7],S8,S9,S10,S11,S12],
		[S1,[S3,Db],[S7,Dc],S4,S5,S6,[S2,Da],S8,S9,S10,S11,S12]):-
	ruota_antiorario(D2,Da), cambia_dir(yz,D3,Db), cambia_dir(xz,D7,Dc). % [b3,g3,b3,g3,b3,g,b,g,b,g]
mossa_s(ba10,[[S1,D1],S2,S3,[S4,D4],S5,S6,[S7,D7],S8,S9,S10,S11,S12],
	     [[S4,Db],S2,S3,[S7,Dc],S5,S6,[S1,Da],S8,S9,S10,S11,S12]):-
	ruota_orario(D1,Da), cambia_dir(yz,D4,Db), cambia_dir(xy,D7,Dc). % [b,a,b,a,b,a3,b3,a3,b3,a3]
mossa_s(b3a310, [S1,S2,[S3,D3],[S4,D4],S5,S6,S7,[S8,D8],S9,S10,S11,S12],
		[S1,S2,[S4,Db],[S8,Dc],S5,S6,S7,[S3,Da],S9,S10,S11,S12]):-
	ruota_orario(D3,Da), cambia_dir(yz,D4,Db), cambia_dir(xy,D8,Dc). % [b3,a3,b3,a3,b3,a,b,a,b,a]
mossa_s(vr10,[[S1,D1],S2,S3,S4,[S5,D5],S6,S7,S8,S9,S10,[S11,D11],S12],
	      [[S5,Db],S2,S3,S4,[S11,Dc],S6,S7,S8,S9,S10,[S1,Da],S12]):-
	ruota_antiorario(D1,Da), cambia_dir(xz,D5,Db), cambia_dir(xy,D11,Dc). % [v,r,v,r,v,r3,v3,r3,v3,r3]
mossa_s(v3r310, [S1,[S2,D2],S3,S4,[S5,D5],S6,S7,S8,S9,S10,S11,[S12,D12]],
		[S1,[S12,Dc],S3,S4,[S2,Da],S6,S7,S8,S9,S10,S11,[S5,Db]]):-
	cambia_dir(xy,D2,Da), cambia_dir(xz,D5,Db), ruota_antiorario(D12,Dc). % [v3,r3,v3,r3,v3,r,v,r,v,r]
mossa_s(va10,[S1,S2,S3,[S4,D4],S5,S6,S7,[S8,D8],S9,S10,S11,[S12,D12]],
	     [S1,S2,S3,[S12,Dc],S5,S6,S7,[S4,Da],S9,S10,S11,[S8,Db]]):-
	cambia_dir(xy,D4,Da), cambia_dir(xz,D8,Db), ruota_antiorario(D12,Dc). % [v,a,v,a,v,a3,v3,a3,v3,a3]
mossa_s(v3a310, [[S1,D1],S2,S3,S4,S5,S6,S7,[S8,D8],[S9,D9],S10,S11,S12],
		[[S8,Db],S2,S3,S4,S5,S6,S7,[S9,Dc],[S1,Da],S10,S11,S12]):-
	ruota_antiorario(D1,Da), cambia_dir(xz,D8,Db), cambia_dir(xy,D9,Dc). % [v3,a3,v3,a3,v3,a,v,a,v,a]
mossa_s(vc10,[S1,S2,S3,S4,[S5,D5],S6,S7,S8,[S9,D9],S10,S11,[S12,D12]],
	     [S1,S2,S3,S4,[S12,Dc],S6,S7,S8,[S5,Da],S10,S11,[S9,Db]]):-
	ruota_orario(D5,Da), cambia_dir(yz,D9,Db), cambia_dir(xz,D12,Dc). % [v,c,v,c,v,c3,v3,c3,v3,c3]
mossa_s(v3c310, [S1,S2,S3,S4,S5,S6,S7,[S8,D8],S9,S10,[S11,D11],[S12,D12]],
		[S1,S2,S3,S4,S5,S6,S7,[S12,Dc],S9,S10,[S8,Da],[S11,Db]]):-
	ruota_orario(D8,Da), cambia_dir(yz,D11,Db), cambia_dir(xz,D12,Dc). % [v3,c3,v3,c3,v3,c,v,c,v,c]
mossa_s(rg10,[S1,[S2,D2],S3,S4,S5,[S6,D6],S7,S8,S9,[S10,D10],S11,S12],
	     [S1,[S6,Db],S3,S4,S5,[S10,Dc],S7,S8,S9,[S2,Da],S11,S12]):-
	ruota_orario(D2,Db), cambia_dir(xy,D6,Da), cambia_dir(xz,D10,Dc). % [r,g,r,g,r,g3,r3,g3,r3,g3]
mossa_s(r3g310, [S1,S2,[S3,D3],S4,S5,[S6,D6],S7,S8,S9,S10,[S11,D11],S12],
		[S1,S2,[S11,Dc],S4,S5,[S3,Da],S7,S8,S9,S10,[S6,Db],S12]):-
	cambia_dir(xz,D3,Da), cambia_dir(xy,D6,Db), ruota_orario(D11,Dc). % [r3,g3,r3,g3,r3,g,r,g,r,g]
mossa_s(rc10,[S1,S2,S3,S4,S5,[S6,D6],S7,S8,S9,S10,[S11,D11],[S12,D12]],
	     [S1,S2,S3,S4,S5,[S11,Db],S7,S8,S9,S10,[S12,Dc],[S6,Da]]):-
	ruota_antiorario(D6,Da), cambia_dir(xy,D11,Db), cambia_dir(yz,D12,Dc). % [r,c,r,c,r,c3,r3,c3,r3,c3]
mossa_s(r3c310, [S1,S2,S3,S4,[S5,D5],S6,S7,S8,S9,[S10,D10],[S11,D11],S12],
		[S1,S2,S3,S4,[S11,Dc],S6,S7,S8,S9,[S5,Da],[S10,Db],S12]):-
	ruota_antiorario(D5,Da), cambia_dir(yz,D10,Db), cambia_dir(xy,D11,Dc). % [r3,c3,r3,c3,r3,c,r,c,r,c]
mossa_s(ga10,[S1,S2,[S3,D3],S4,S5,S6,S7,[S8,D8],[S9,D9],S10,S11,S12],
	     [S1,S2,[S8,Db],S4,S5,S6,S7,[S9,Dc],[S3,Da],S10,S11,S12]):-
	ruota_antiorario(D3,Da), cambia_dir(xz,D8,Db), cambia_dir(xy,D9,Dc). % [g,a,g,a,g,a3,g3,a3,g3,a3]
mossa_s(g3a310, [S1,S2,S3,[S4,D4],S5,S6,S7,[S8,D8],S9,[S10,D10],S11,S12],
		[S1,S2,S3,[S10,Dc],S5,S6,S7,[S4,Da],S9,[S8,Db],S11,S12]):-
	cambia_dir(xy,D4,Da), cambia_dir(xz,D8,Db), ruota_antiorario(D10,Dc). % [g3,a3,g3,a3,g3,a,g,a,g,a]
mossa_s(gc10,[S1,S2,S3,S4,S5,S6,[S7,D7],S8,S9,[S10,D10],[S11,D11],S12],
	     [S1,S2,S3,S4,S5,S6,[S10,Db],S8,S9,[S11,Dc],[S7,Da],S12]):-
	ruota_orario(D7,Da), cambia_dir(xz,D10,Db), cambia_dir(yz,D11,Dc). % [g,c,g,c,g,c3,g3,c3,g3,c3]
mossa_s(g3c310, [S1,S2,S3,S4,S5,[S6,D6],S7,S8,[S9,D9],[S10,D10],S11,S12],
		[S1,S2,S3,S4,S5,[S10,Dc],S7,S8,[S6,Da],[S9,Db],S11,S12]):-
	ruota_orario(D6,Da), cambia_dir(yz,D9,Db), cambia_dir(xz,D10,Dc). % [g3,c3,g3,c3,g3,c,g,c,g,c]
mossa_s(ac10,[S1,S2,S3,S4,S5,S6,S7,[S8,D8],[S9,D9],[S10,D10],S11,S12],
	     [S1,S2,S3,S4,S5,S6,S7,[S9,Db],[S10,Dc],[S8,Da],S11,S12]):-
	ruota_antiorario(D8,Da), cambia_dir(xy,D9,Db), cambia_dir(yz,D10,Dc). % [a,c,a,c,a,c3,a3,c3,a3,c3]
mossa_s(a3c310, [S1,S2,S3,S4,S5,S6,[S7,D7],S8,[S9,D9],S10,S11,[S12,D12]],
		[S1,S2,S3,S4,S5,S6,[S9,Db],S8,[S12,Dc],S10,S11,[S7,Da]]):-
	ruota_antiorario(D7,Da), cambia_dir(xy,D9,Db), cambia_dir(yz,D12,Dc). % [a3,c3,a3,c3,a3,c,a,c,a,c]
% Mosse singole, senza calcolare i vertici.
mossa_s(g3,[E,F,[S3,T3],G,H,[S6,T6],[S7,T7],I,J,[S10,T10]|Rest_s],  
	[E,F,[S6,Tb],G,H,[S10,Td],[S3,Ta],I,J,[S7,Tc]|Rest_s]) :-
	cambia_dir(xz,T3,Ta),cambia_dir(xz,T6,Tb),cambia_dir(xz,T7,Tc),cambia_dir(xz,T10,Td).
mossa_s(r3,[E,[S2,T2],F,G,[S5,T5],[S6,T6],H,I,J,K,[S11,T11],L],  
	[E,[S5,Tb],F,G,[S11,Td],[S2,Ta],H,I,J,K,[S6,Tc],L]) :-
	cambia_dir(xy,T2,Ta),cambia_dir(xy,T5,Tb),cambia_dir(xy,T6,Tc),cambia_dir(xy,T11,Td).
mossa_s(b,[[S1,T1],[S2,T2],[S3,T3],[S4,T4]|Rest_s],  [[S4,Td],[S1,Ta],[S2,Tb],[S3,Tc]|Rest_s]) :-
	cambia_dir(yz,T1,Ta),cambia_dir(yz,T2,Tb),cambia_dir(yz,T3,Tc),cambia_dir(yz,T4,Td).
mossa_s(v,[[S1,T1],E,F,G,[S5,T5],H,I,[S8,T8],J,K,L,[S12,T12]], 
	[[S5,Tb],E,F,G,[S12,Td],H,I,[S1,Ta],J,K,L,[S8,Tc]]) :-
	cambia_dir(xz,T1,Ta),cambia_dir(xz,T5,Tb),cambia_dir(xz,T8,Tc),cambia_dir(xz,T12,Td).
mossa_s(r,[E,[S2,T2],F,G,[S5,T5],[S6,T6],H,I,J,K,[S11,T11],L],  
	[E,[S6,Tc],F,G,[S2,Ta],[S11,Td],H,I,J,K,[S5,Tb],L]) :-
	cambia_dir(xy,T2,Ta),cambia_dir(xy,T5,Tb),cambia_dir(xy,T6,Tc),cambia_dir(xy,T11,Td).
mossa_s(g,[E,F,[S3,T3],G,H,[S6,T6],[S7,T7],I,J,[S10,T10]|Rest_s],  
	[E,F,[S7,Tc],G,H,[S3,Ta],[S10,Td],I,J,[S6,Tb]|Rest_s]) :-
	cambia_dir(xz,T3,Ta),cambia_dir(xz,T6,Tb),cambia_dir(xz,T7,Tc),cambia_dir(xz,T10,Td).
mossa_s(a,[E,F,G,[S4,T4],[S5,T5],H,I,[S8,T8],J,K,L,[S12,T12]], 
	[E,F,G,[S5,Tb],[S12,Td],H,I,[S4,Ta],J,K,L,[S8,Tc]]) :-
	cambia_dir(xy,T4,Ta),cambia_dir(xy,T5,Tb),cambia_dir(xy,T8,Tc),cambia_dir(xy,T12,Td).
mossa_s(c,[E,F,G,H,I,J,K,L,[S9,T9],[S10,T10],[S11,T11],[S12,T12]],   
	[E,F,G,H,I,J,K,L,[S12,Td],[S9,Ta],[S10,Tb],[S11,Tc]]) :-
	cambia_dir(yz,T9,Ta),cambia_dir(yz,T10,Tb),cambia_dir(yz,T11,Tc),cambia_dir(yz,T12,Td).

% RUOTA_ORARIO e RUOTA_ANTIORARIO
ruota_orario(x,y):- !.
ruota_orario(y,z):- !.
ruota_orario(z,x).
ruota_antiorario(y,x):- !.
ruota_antiorario(z,y):- !.
ruota_antiorario(x,z).
% CAMBIA_DIR
cambia_dir(xy,z,z):- !. 
cambia_dir(xy,x,y):- !.
cambia_dir(xy,y,x).
cambia_dir(xz,y,y):- !.
cambia_dir(xz,x,z):- !.
cambia_dir(xz,z,x).
cambia_dir(yz,x,x):- !.
cambia_dir(yz,y,z):- !.
cambia_dir(yz,z,y).

% INIZIALIZZAZIONE
spigoli_ko([[ba,y],[bv,x],[ga,y],[bg,z],[cv,x],[br,z],[ca,z],[cr,y],[va,x],[gr,y],[cg,x],[vr,z]]).
% GO
go:- spigoli_ko(S), trova_spigoli(S,12,1). % 12 spigoli fuori posto ed 1 passo di ricerca in profondit.

% TROVA_SPIGOLI	
trova_spigoli(S,Diversi,Profondit_max):- posizione_spigoli(S,Sequenza,Diversi,Profondit_max,0),
	conta_mosse(Sequenza,Numero_mosse), calcola_stato_spigoli(S,Sequenza,Sn), spigoli_fuori_posto(Sn,FP,D), 
	write('Dopo '), write(Numero_mosse), write(' mosse ('), write(Sequenza), write(') ,'), write(D), 
	write(' spigoli fuori posto.'), nl, write(FP), nl, write(Sn), nl, spigoli_ok(S_ok), write(S_ok), write('  il goal.'),
	nl, trova_spigoli(Sn,D).
trova_spigoli(S,Diversi,Profondit_max):- 
	P is Profondit_max+1, write('profondit: '), Pr is P-1, write(Pr),nl, trova_spigoli(S,Diversi,P).
trova_spigoli(_,0).
trova_spigoli(Spigoli,Diversi):- trova_spigoli(Spigoli,Diversi,1). 

% POSIZIONE_SPIGOLI
% Cerca di trovare una sequenza di mosse che porti ad avere un numero minore di "Diversi" spigoli fuori posto.
posizione_spigoli(S,[],Diversi,_,_):-	n_spigoli_fuori_posto(S,N), Diversi>N, !.		% ho trovato!
posizione_spigoli(_,_,_,Profondit_max,Profondit_max):- !, fail. % forzo il backtracking
posizione_spigoli(Spigoli,[Mossa|Sequenza],Diversi,Profondit_max,Profondit):- mossa_s(Mossa,Spigoli,Sn),
	P is Profondit+1, posizione_spigoli(Sn,Sequenza,Diversi,Profondit_max,P).

% CONTA_MOSSE
conta_mosse(Sequenza,Numero_mosse):- length(Sequenza,0,Numero_mosse).
length([],N,N).
length([_|T],Acc,Numero_mosse):- Acc1 is Acc+1, length(T,Acc1,Numero_mosse).

% SPIGOLI_FUORI_POSTO
spigoli_fuori_posto(Spigoli,FP,N):- spigoli_ok(S_ok), spigoli_fuori_posto(Spigoli,S_ok,FP,0,N).
spigoli_fuori_posto([],[],[],N,N).
spigoli_fuori_posto([[H,_]|T],[[H,_]|T1],L,Acc,N):-  !, spigoli_fuori_posto(T,T1,L,Acc,N).
spigoli_fuori_posto([[H,O]|T],[[H1,O1]|T1],[[[H,O],[H1,O1]]|L],Acc,N):- 
	Acc1 is Acc+1, spigoli_fuori_posto(T,T1,L,Acc1,N).

% N_SPIGOLI_FUORI_POSTO
n_spigoli_fuori_posto(Spigoli,N):- spigoli_ok(S_ok), n_spigoli_fuori_posto(Spigoli,S_ok,0,N).
n_spigoli_fuori_posto([],[],N,N).
n_spigoli_fuori_posto([[H,_]|T],[[H,_]|T1],Acc,N):- !, n_spigoli_fuori_posto(T,T1,Acc,N).
n_spigoli_fuori_posto([_|T],[_|T1],Acc,N):- Acc1 is Acc+1, n_spigoli_fuori_posto(T,T1,Acc1,N).

% CALCOLA_STATO_SPIGOLI
calcola_stato_spigoli(S,[],S).
calcola_stato_spigoli(S,[Mossa|Sequenza],Sn):- mossa_s(Mossa,S,S1), calcola_stato_spigoli(S1,Sequenza,Sn).
